/*
 * =====================================================================================
 *
 *       Filename:  othello.h
 *
 *    Description:  Header for othello board handling functions
 *
 *        Version:  1.0
 *        Created:  25/04/2017 15:16:37
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Jerome Benoit (fraggle), jerome.benoit@piment-noir.org
 *   Organization:  Piment Noir
 *
 * =====================================================================================
 */

#ifndef OTHELLO_H
#define OTHELLO_H

#include "constants.h"
#include "list.h"

struct shots_list {
    struct list_head list;
    unsigned int*** pawn_array_member;
};

unsigned int current_player(unsigned int round_count);

int** init_pawns(unsigned int pawn_array[board_size][board_size]);

bool is_valid_input(int y, int x, unsigned int pawn_array[board_size][board_size]);
bool is_box_type(int y, int x, unsigned int pawn_array[board_size][board_size], unsigned int type);
bool is_board_full(unsigned int pawn_array[board_size][board_size]);
unsigned int get_box_value(int y, int x, unsigned int pawn_array[board_size][board_size]);
int** set_pawn(int y, int x, unsigned int type, unsigned int pawn_array[board_size][board_size]);

unsigned int count_pawn_type(unsigned int pawn_array[board_size][board_size], unsigned int type);

#endif /* OTHELLO_H */
